<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class="">
      <h1>Job Seekers</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
        <el-breadcrumb-item>Job Seekers</el-breadcrumb-item>
      </el-breadcrumb>
    </div>
    <br />

    <el-card
      class="box-card"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    >
      <div class="card-header">

      </div>
      <el-table
        id="style-3"
        rowClassName="pointer-row"
        :data="list"
      >
        <el-table-column
          fixed
          prop="id"
          label="ID"
          width="100"
        >
        </el-table-column>
        <el-table-column
          fixed
          prop="date"
          label="Avatar"
          width="120"
        >
          <template slot-scope="scope">
            <img
              class="img-responsive"
              @click="showAvatar(scope.row.user ? scope.row.user.avatar_url : null, $event)"
              :src="(scope.row.user && scope.row.user.avatar_url) ? scope.row.user.avatar_url : $store.state.avtHolder"
            />
          </template>
        </el-table-column>
        <el-table-column
          cell-class-name="cell-email"
          min-width="200"
          prop="email"
          label="Email"
        >
        </el-table-column>
        <el-table-column
          min-width="150"
          prop="createDate"
          label="Created at"
        >
          <template slot-scope="scope">
            <span>{{scope.row.createDate | moment('DD-MM-YYYY') }}</span>
          </template>
        </el-table-column>
        <el-table-column
          min-width="150"
          prop="updateDate"
          label="Updated at"
        >
          <template slot-scope="scope">
            <span>{{scope.row.updateDate | moment('DD-MM-YYYY') }}</span>
          </template>
        </el-table-column>
        <el-table-column
          prop="isActive"
          label="Status"
          min-width="150"
        >
          <template slot-scope="scope">
            <div
              v-if="scope.row.isActive"
              style=""
            >
              <el-tag
                v-if="scope.row.isActive == '1'"
                style="min-width: 120px; text-align:center;"
                type="success"
                size="small"
                class="font-weight-500"
              >
                Active
              </el-tag>
              <el-tag
                v-if="scope.row.isActive == '0'"
                style="min-width: 120px; text-align:center;"
                type="danger"
                size="small"
                class="font-weight-500"
              >
                Inactive
              </el-tag>

            </div>
          </template>
        </el-table-column>
        <el-table-column
          prop="isActive"
          label="Action"
          min-width="150"
        >

          <template slot-scope="scope">
            <div
              v-if="scope.row.isActive == 0"
              style=""
            >
              <el-button
                @click="updateStatus(scope.row.id,1)"
                class="txt-verify verified"
                type="success"
              >
                Active
              </el-button>
            </div>
            <div
              v-if="scope.row.isActive == 1"
              style=""
            >
              <el-button
                @click="updateStatus(scope.row.id,0)"
                class="txt-verify verified"
                type="danger"
              >
                Disable
              </el-button>
            </div>
          </template>
        </el-table-column>
      </el-table>
      <div
        class="flex justify-space-between"
        style="align-items:center;"
      >

        <!-- <el-pagination
          v-if="total > pageSize"
          class="right"
          background
          layout="prev, pager, next"
          style="margin-top: 20px, display:inline-block"
          :current-page="currentPage"
          :page-size="pageSize"
          @current-change="onChangePage"
          :total="total"
        >
        </el-pagination> -->

      </div>
    </el-card>

  </div>

</template>

<script>
import helper from '~/services/helper';
import _ from 'lodash';
import { seeker as seekerApi, category as categoryAPI } from '~/services/apis/index'

export default {
  name: 'JobsSeeker',
  data () {
    return {
      search: '',
      dialogvisible: false,
      imageUrl: null,
      pageWidth: 0,
      list: [],
      loading: true,
      filterLoading: true,
      currentPage: 1,
      total: 0,
      pageSize: this.$store.state.itemPerPage,
      defaultFilter: {},
      sortBy: "",
      dir: "",


      datePicker: '',
      from_date: null,
      to_date: null,
      categorySelected: null,

    }
  },
  components: {

  },

  computed: {
    contactsFiltered () {
      return this.contacts.filter(({ id }) => {
        return true;
      });
    },
    contactsClass () {
      return this.pageWidth >= 870 ? 'large' : this.pageWidth >= 760 ? 'medium' : 'small'
    },
    onSubmit () {
      return this.$store.state.searchSubmit;
    }
  },

  watch: {
    onSubmit () {
      this.onSearch()
    },
    '$route.query' () {
      this.initParams();
      this.getListData();
    }
  },
  methods: {
    updateStatus (row, data) {
      if (data == 0) {
        this.$confirm('Are you sure you want to deactive this user?', 'Warning', {
          confirmButtonText: 'Yes',
          cancelButtonText: 'Cancel',
          type: 'warning',
          center: true
        }).then(() => {
          this.loading = true
          //eslint-disable-next-line
          console.log('row,data :', row, data);
          seekerApi.updateStatus(row, { isActive: data }).then(res => {
            if (res.status == 200) {
              this.$notify({
                title: "success",
                message: "Update status user successfully!",
                type: "success"
              });
              this.getListData()
            }
          }).catch(error => {
            this.$notify({
              title: "Error",
              message: "Cannot update status user!",
              type: "error"
            });
            this.loading = false
          })
        }).catch(error => {

        })
      } else if (data == 1) {
        this.loading = true
        //eslint-disable-next-line
        console.log('row,data :', row, data);
        seekerApi.updateStatus(row, { isActive: data }).then(res => {
          if (res.status == 200) {
            this.$notify({
              title: "success",
              message: "Update status user successfully!",
              type: "success"
            });
            this.getListData()
          }
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot update status user!",
            type: "error"
          });
          this.loading = false
        })
      }

    },
    openDialog (data) {
      this.userdata = data
      this.dialogvisible = true
    },

    getListData () {

      this.loading = true;


      seekerApi.getSeekers(
      ).then((res) => {
        this.list = [...res.data];
        this.loading = false;

      }).catch(err => {
        this.$notify({
          title: "Error",
          message: "Cannot get data from server!",
          type: "error"
        });
        this.not_found = true
        this.loading = false;
      })
    },
    showDetail (row) {
      var selection = window.getSelection();
      if (selection.toString().length !== 0) return;

      var id = row.id;
      this.$router.push({ name: 'job_seekers_detail', params: { id } });

    },
    /* Init Params query*/

    onChangePage (page) {


      this.query = this.$route.query;
      this.query.page = page
      this.updateRoute(this.query);
    },



    /* filter onChange*/

    onSearch () {
      this.search = this.$store.state.search;
      this.currentPage = 1;


      this.query.page = this.currentPage;
      this.query.q = this.search;
      this.updateRoute(this.query);
      this.$store.commit("setSearchValue", this.search);
    },
    showAvatar (url, event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (!url) return;
      this.imageUrl = url;
      this.dialogvisible = true;
    },

  },
  created () {
    this.getListData();
  },
  mounted () {

  },

}
</script>

<style lang="scss" scoped>
@import "../../../assets/scss/_variables";
.filter-verify-jobseeker {
  margin-right: 10px;
}
.img-profile img {
  height: 200px;
  width: 200px;
  border-radius: 10px;
  box-sizing: border-box;
  border: 5px solid #fff;
  box-shadow: 0 7px 20px -7px rgba(0, 0, 0, 0.55);
}

.btn-eye {
  padding: 1px 6px;
}
.page-contacts {
  height: 100%;
  margin: 0 !important;
  padding: 20px;
  padding-bottom: 10px;
  box-sizing: border-box;

  .search-card {
    padding: 50px;
    max-width: 350px;
    max-height: 320px;
    box-sizing: border-box;
    margin-bottom: 15px;

    .el-input,
    .el-button {
      width: 100%;
    }
  }

  .search-wrap {
    margin: 0 auto;
    margin-bottom: 10px;
    padding: 0px 30px;
    box-sizing: border-box;
    width: 100%;
    max-width: 600px;

    i {
      display: inline-block;
      width: 22px;
    }

    input {
      outline: none;
      background: transparent;
      border: none;
      font-size: 15px;
      position: relative;
      top: -2px;
      width: 100%;
      padding: 0;
      color: $text-color;
    }

    .contacts-tot {
      margin-right: 20px;
      margin-left: 10px;
    }

    a {
      border-bottom: 1px solid;
      text-decoration: none;
      color: $text-color;

      &:hover {
        opacity: 0.6;
      }
    }
  }

  .contacts-root {
    max-height: 100%;
  }

  .contacts-list {
    //margin: 0 auto;
    width: 100%;
    max-width: 965px;
    padding: 0px 30px;
    box-sizing: border-box;

    .contact {
      margin: 10px 0;
      padding: 5px;
      box-sizing: border-box;
      cursor: pointer;
      transition: all 0.5s 0.25s;

      .star {
        .mdi-star {
          color: #ffd730;
        }
        .mdi-star-outline {
          opacity: 0.5;
        }
      }

      .avatar {
        width: 60px;
        transition: all 0.5s 0.25s;

        img {
          border: 1px solid transparentize($text-color, 0.9);
          box-sizing: border-box;
          width: 50px;
          height: 50px;
          border-radius: 50%;
          transition: all 0.5s 0.25s;
        }
      }

      .info {
        word-break: break-word;

        .name {
          //.fullname {}

          .email {
            opacity: 0;
            line-height: 0;
            transition: all 0.5s 0.25s;
          }

          .phone {
            display: none;
          }
        }

        //.phone {}
      }

      &:hover {
        margin: 15px -20px;
        padding: 10px;
        background-color: lighten($background-color, 20%);
        border-radius: 5px;
        box-shadow: 0 8px 16px 0 rgba(40, 40, 90, 0.09),
          0 3px 6px 0 rgba(0, 0, 0, 0.065);

        .avatar {
          width: 90px;

          img {
            width: 90px;
            height: 90px;
          }
        }

        .info {
          .name {
            .email {
              opacity: 1;
              line-height: 1.4;
            }
          }
        }
      }
    }
  }

  .contacts-root {
    &.medium {
      .search-card {
        padding: 20px;
        max-width: 260px;
        max-height: 260px;
      }
    }
    &.small {
      overflow-y: auto;
      display: block;
      -webkit-box-orient: vertical;
      -webkit-box-direction: normal;
      -ms-flex-direction: column;
      flex-direction: column;
      padding: 5px;

      .search-card {
        padding: 20px;
        max-width: 100%;
        width: 100%;
        //max-height: 240px;
        flex: none;
        -webkit-box-flex: none;
        -ms-flex: none;
        display: block;
        overflow: hidden !important;
      }

      .contacts-list {
        flex: none;
        -webkit-box-flex: none;
        -ms-flex: none;
        display: block;
        overflow: hidden !important;
      }
    }
  }
}

@media (max-width: 768px) {
  .page-contacts {
    .search-wrap {
      padding: 0;
    }
    .contacts-list {
      padding: 0px;

      .contact {
        .avatar {
          width: 40px;

          img {
            width: 40px;
            height: 40px;
          }
        }

        .info {
          .phone {
            display: none;
          }

          .name {
            .phone {
              display: block;
            }
          }
        }

        &:hover {
          margin: 15px 0px;

          .avatar {
            width: 60px;

            img {
              width: 60px;
              height: 60px;
            }
          }
        }
      }
    }

    .contacts-root {
      &.medium {
        .contacts-list {
          padding: 0 30px;
        }
      }
      &.small {
        .contacts-list {
          padding: 8px;
        }
      }
    }
  }
}
</style>

